## Copyright (C) 2024 Patrick_Pluto
##
## This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3.
##
## This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License along with this program. If not, see <https://www.gnu.org/licenses/>. 

extends StaticBody3D

const TARGET = 100
var current = 0

var pc_occupied = [0, 0, 0]

var pc_body = [0, 0, 0]

func _ready():
	Game.computers += 1

func _on_computer_tick_timeout():
	if Server.is_server:
		current += (pc_occupied[0] + pc_occupied[1] + pc_occupied[2])
		Server.sync_computers.rpc(name, current)
	if current >= TARGET:
		current = "Complete"
		$computer_tick.stop()
		Game.computers -= 1
	$pc_1/Label3D.text = str(current)
	$pc_2/Label3D.text = str(current)
	$pc_3/Label3D.text = str(current)


func _on_pc_1_area_body_entered(body):
	if pc_occupied[0] == 0 and !body.beast:
		pc_occupied[0] = 1
		pc_body[0] = body


func _on_pc_2_area_body_entered(body):
	if pc_occupied[1] == 0 and !body.beast:
		pc_occupied[1] = 1
		pc_body[1] = body


func _on_pc_3_area_body_entered(body):
	if pc_occupied[2] == 0 and !body.beast:
		pc_occupied[2] = 1
		pc_body[2] = body


func _on_pc_1_area_body_exited(body):
	if pc_occupied[0] == 1 and body == pc_body[0]:
		pc_occupied[0] = 0
		pc_body[0] = 0


func _on_pc_2_area_body_exited(body):
	if pc_occupied[1] == 1 and body == pc_body[1]:
		pc_occupied[1] = 0
		pc_body[1] = 0


func _on_pc_3_area_body_exited(body):
	if pc_occupied[2] == 1 and body == pc_body[2]:
		pc_occupied[2] = 0
		pc_body[2] = 0
